/*
 * Author     :  Paul Kocher
 * E-mail     :  pck@netcom.com
 * Date       :  1997
 * Description:  C implementation of the Blowfish algorithm.
 */

#define MAXKEYBYTES 56          /* 448 bits */

typedef struct {

  unsigned long P[16 + 2];

  unsigned long S[4][256];

} BLOWFISH_CTX;

void blowfish_init(BLOWFISH_CTX *ctx, unsigned char *key, int keyLen);

void blowfish_encrypt(BLOWFISH_CTX *ctx, unsigned long *xl, unsigned long
*xr);

void blowfish_decrypt(BLOWFISH_CTX *ctx, unsigned long *xl, unsigned long
*xr);

int blowfish_Test(BLOWFISH_CTX *ctx);       /* 0=ok, -1=bad */
