
/*
 *      $Source: /home/fergia/CVS/tcfs-linux/tcfslib-1.0.0/include/tcfs_errno.h,v $
 *      $Revision: 1.1.1.1 $
 *      $Date: 2000/04/07 11:21:23 $
 *      $State: Exp $
 *      $Author: fergia $
 *      $Lockers$
 */

/* START OF ERROR SECTION */

/* tcfs_errno is defined in tcfs_global.c */ 
extern int tcfs_errno;

enum
{
	OK=0,		/* 0 - Ok, no error */
	ER_MEM,        	/* 1 - Out of memory error - u */
	ER_PERM,       	/* 2 - Error calling TCFS_IOC_PERMANENT ioctl - u*/
	ER_ENABLE,     	/* 3 - Error calling TCFS_IOC_LOGIN ioctl - u*/
	ER_DISABLE,     /* 4 - Error calling TCFS_IOC_DISABLE ioctl - u*/
	ER_COUNT,       /* 5 - Error calling TCFS_IOC_COUNT ioctl - u*/
	ER_UNKGDBMOPER, /* 6 - Unknown GDBM operation */ 
	ER_GDBMOPEN,	/* 7 - Failed to open the GDBM [group] key's file */
	ER_GDBMSTORE, 	/* 8 - Failed to store an entry in the GDBM [group] 					key's file */
	ER_GDBMDELETE,	/* 9 - Failed to delete an entry in the GDBM [group] 					key's file */
	ER_GDBMEXIST,	/* 10 - Failed to acces to the GDBM [group] key's file. 				Reason:	file doesn't exist */
	ER_GDBMNODATA, 	/* 11 - No data found in the GDBM [group] key's file */
	ER_MAXUSER,	/* 12 - User's length must be less or equal then 					Userlen */
	ER_MAXKEY,	/* 13 - The key's lenght must be less or equal then				PassLen */
	ER_PWTEXTOPEN,	/* 14 - Failed to open the text key's file */
	ER_PWTEXTLOCKED,/* 15 - The text key's file is just open in write mode 				*/
	ER_PWTEXTLOCK,	/* 16 - Failed to lock text key's file */
	ER_PWTEXTEXIST,	/* 17 - Entry is in text key's file. I can't replace it 			*/ 
	ER_PWTEXTNOTEXIST,	/* 18 - Entry is not in the text key's file. */
	ER_PWTEXTREPLACE,	/* 19 - Failed to replace an entry in the text 					key's file. */	
	
	ER_BASE64_MAX,	/* 20 - You've specified a string to encode greater than			the max allowed. */
	ER_BASE64_ILLCHR,	/* 21 - illegal base64 character */
	ER_BASE64_MUL,	/* 22 - The length of string to decode must be multiple 			of 4 */
	
	ER_CONF_FILE,	/* 23 - Error on read the dynamic library's 					configuration file */
	ER_BAD_CONF_FILE,	/* 24 - Bad format of dynamic library's 					configuration file */
	ER_LOAD_LIBRARY,	/* 25 - Error on loading dynamic library */
	ER_LOAD_FUNCTION,	/* 26 - Error on loading a function from dynamic library */

	ER_MTAB_OPEN,	/* 27 - Failed to open the mtab file */
	ER_IOCTL,	/* 28 - Error on ioctl. */
	ER_NO_TCFS_MOUNTED, /* 29 - No tcfs file mounted */
	ER_TCFS_OPEN,	/* 30 - Failed to read a tcfs filesystem */
	ER_TCFS_DECRYPT,	/* 31 - Error on decrypting key. Unexpected key length */
	ER_VERSION,	/* 32 - Ioctl error getting version */

	ER_NOTERMINAL,	/* 33 - Input device is not a terminal device */
	ER_SETTERMINAL	/* 34 - Error setting terminale device */
};

#define MAX_ERRORS	35


/* FUNCTION PROTOTYPES */

const char* tcfs_strerror(int);

/* END OF ERROR SECTION */


