
/*
 *      $Source: /home/fergia/CVS/tcfs-linux/tcfslib-1.0.0/include/tcfs_key.h,v $
 *      $Revision: 1.1.1.1 $
 *      $Date: 2000/04/07 11:21:24 $
 *      $State: Exp $
 *      $Author: fergia $
 *      $Lockers$
 */

/* START OF KEY MANAGEMENT SECTION */

#include <linux/tcfs.h> 	/* NUM_CIPHER is defined */

/* This is used to refer to the cipher dynamic library's function  */
#define TCFS_INIT_KEY	"tcfs_init_key"
#define TCFS_ENCRYPT	"tcfs_encrypt"
#define TCFS_DECRYPT	"tcfs_decrypt"
#define TCFS_DELETE_KEY	"tcfs_delete_key"  

/* This is the name of the file that defines the cipher to use */
#define TCFS_CIPHER_CONF "/etc/cipher.conf"

/* This are the keyword of the dynamic library's configuration file */
#define TCFS_CIPHER_KEYWORD	"cipher"

#define TCFS_CIPHER_COMMENT	'#'
#define DELIM 			"\t \n"

#define TCFS_MTAB_PATH 	"/etc/mtab"

#define TCFS_USER_KEY	0 	/* It's used in the encrypt/decrypt function */
#define TCFS_GROUP_KEY	1

#define TCFS_COUNTER_ONE 1	/* It is used to decrement the key counter by 1 */
#define TCFS_COUNTER_ALL 2	/* It is used to remove all the keys */
#define TCFS_SET_FLAG	3	/* It is used to set the permanent flag */
#define TCFS_DEL_FLAG	4	/* It is used to unset the permanent flag */

static const char* tcfs_engines[NUM_CIPHER]= {
	"none","DES","IDEA","RC5"
};

/* FUNCTION PROTOTYPES */

char* gentcfskey(void);
char* tcfs_encrypt_key(char*, char*, int);
char* tcfs_decrypt_key(char*, char*, int);
int tcfs_enable(__kernel_uid_t, char *, char *);
int tcfs_disable(__kernel_uid_t, char *, int flag);
int tcfs_group_enable(__kernel_uid_t, __kernel_gid_t, unsigned int, char *,
		char *);
int tcfs_group_disable(__kernel_uid_t, __kernel_gid_t, char *, int);
int tcfs_permanent(__kernel_uid_t, char *, int);
int tcfs_group_permanent(__kernel_uid_t, __kernel_gid_t, char *, int);
int tcfs_getcount(void);
int tcfs_group_getcount(int);
int tcfs_getpermanent(void);
int tcfs_group_getpermanent(int);
int tcfs_getversion(short*, short*, char**);
int tcfs_encrypt_file(char *, char *, int);
int tcfs_decrypt_file(char *);
int tcfs_change_cipher(char *, char *);
struct tcfs_header *tcfs_get_header (char *);

/* END OF KEY MANAGEMENT SECTION */


