/*
 *      $Source: /home/fergia/CVS/tcfs-linux/tcfslib-1.0.0/src/tcfs_errno.c,v $
 *      $Revision: 1.1.1.1 $
 *      $Date: 2000/04/07 11:21:24 $
 *      $State: Exp $
 *      $Author: fergia $
 *      $Lockers$
 */

#include <stdio.h>
#include "tcfs_errno.h"

static const char *tcfs_errors_list[MAX_ERRORS]=
{
	"Ok",
	"Error getting memory.",
	"Ioctl error while using permanent flag.",
	"Ioctl error while sending key.",
	"Ioctl error while removing key.",
	"Ioctl error while getting key counter.",
	"Unknow gdbm operation.",
	"Failed to open the TCFS key's database.",
	"Failed to store an entry into TCFS key's database.",
	"Failed to delete an entry into TCFS key's database.",
	"Failed to access to TCFS key's database.",
	"No data found into TCFS key's database.",
	"Reached the maximum value of user's length.",
	"Reached the maximum value of key's length.",
	"Failed to open the text key's file.",
	"Text key's file is just open in write mode.",
	"Failed to lock text key's file.",
	"Entry is in text key's file. I can't replace it.", 
	"Entry is not in the text key's file.",
	"Failed to replace an entry in the text	key's file.", 	
	"The string to encode is greater than the maximum allowed.",
	"Illegal base64 character.",
	"The length of string to decode isn't multiple of 4.",
	"Error on read the dynamic library's configuration file.",
	"Bad format of dynamic library's configuration file.",
	"Error on loading dynamic library.",
	"Error on loading a function from dynamic library.",
	"Failed to open the mtab file.",
	"Error on ioctl.",
	"No TCFS filesystem mounted.",
	"Failed to read a tcfs filesystem.",
	"Error on decrypting key: unexpected key length.",
	"Ioctl error while getting version.",
	"Input device is not a terminal device.",
	"Error setting terminal properties."
};

const char* tcfs_strerror(int error) {
	
	if ((error<0) || (error>=MAX_ERRORS))
		return("Unkonwn error.");

	return(tcfs_errors_list[error]);
}

