/*
 *      $Source: /home/fergia/CVS/tcfs-linux/tcfsutils-2.0.0/src/auth.c,v $
 *      $Revision: 1.1.1.1 $
 *      $Date: 2000/04/07 11:21:26 $
 *      $State: Exp $
 *      $Author: fergia $
 *      $Lockers$
 */

/* Thanks to Usui Takayuki (takajuki@satan.genesis.ne.jp) for the
 * Shadow Password support
 */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "tcfslib.h"

#ifdef SHADOW_PASSWORD
#include <shadow.h>
#else
#include <pwd.h>
#endif

extern char* crypt(const char*, const char*);

/* unix_auth is used to authenticate an user. Return 0 if OK, -1 on error. */

int auth (char *user, char *password)
{

#ifdef SHADOW_PASSWORD
	struct spwd *shadow;
#else
	struct passwd *pass;
#endif

	
#ifdef SHADOW_PASSWORD
	if ((shadow=getspnam(user))==NULL)
		return -1;


	if (strcmp(crypt (password, shadow->sp_pwdp), shadow->sp_pwdp)!=0)
	{
#else
	if ((pass=getpwnam(user))==NULL)
		return -1;

	if (strcmp (crypt (password, pass->pw_passwd), pass->pw_passwd)!=0)
	{
#endif
		return -1;
	}

	return 0;
}
